! This file was automatically generated by SWIG (http://www.swig.org).
! Version 4.1.0+fortran
!
! Do not make changes to this file unless you know what you are doing--modify
! the SWIG interface file instead.

! STRUMPACK -- STRUctured Matrices PACKage, Copyright (c) 2014, The
! Regents of the University of California, through Lawrence Berkeley
! National Laboratory (subject to receipt of any required approvals
! from the U.S. Dept. of Energy).  All rights reserved.
!
! If you have questions about your rights to use or distribute this
! software, please contact Berkeley Lab's Technology Transfer
! Department at TTD@lbl.gov.
!
! NOTICE. This software is owned by the U.S. Department of Energy. As
! such, the U.S. Government has been granted for itself and others
! acting on its behalf a paid-up, nonexclusive, irrevocable,
! worldwide license in the Software to reproduce, prepare derivative
! works, and perform publicly and display publicly.  Beginning five
! (5) years after the date permission to assert copyright is obtained
! from the U.S. Department of Energy, and subject to any subsequent
! five (5) year renewals, the U.S. Government is granted for itself
! and others acting on its behalf a paid-up, nonexclusive,
! irrevocable, worldwide license in the Software to reproduce,
! prepare derivative works, distribute copies to the public, perform
! publicly and display publicly, and to permit others to do so.
!
! Developers: Pieter Ghysels, Francois-Henry Rouet, Xiaoye S. Li.
!             (Lawrence Berkeley National Lab, Computational Research
!             Division).
!
!> @file strumpack_dense.f90
!> @brief Fortran interface to the structured matrix functionality
!
module strumpack_dense
 use, intrinsic :: ISO_C_BINDING
 implicit none
 private

 ! DECLARATION CONSTRUCTS
 ! typedef enum SP_STRUCTURED_TYPE
 enum, bind(c)
  enumerator :: SP_TYPE_HSS = 0
  enumerator :: SP_TYPE_BLR
  enumerator :: SP_TYPE_HODLR
  enumerator :: SP_TYPE_HODBF
  enumerator :: SP_TYPE_BUTTERFLY
  enumerator :: SP_TYPE_LR
  enumerator :: SP_TYPE_LOSSY
  enumerator :: SP_TYPE_LOSSLESS
 end enum
 integer, parameter, public :: SP_STRUCTURED_TYPE = kind(SP_TYPE_HSS)
 public :: SP_TYPE_HSS, SP_TYPE_BLR, SP_TYPE_HODLR, SP_TYPE_HODBF, SP_TYPE_BUTTERFLY, SP_TYPE_LR, SP_TYPE_LOSSY, &
    SP_TYPE_LOSSLESS
 ! struct struct CSPOptions
 type, bind(C), public :: CSPOptions
  integer(C_INT), public :: type
  real(C_DOUBLE), public :: rel_tol
  real(C_DOUBLE), public :: abs_tol
  integer(C_INT), public :: leaf_size
  integer(C_INT), public :: max_rank
  integer(C_INT), public :: verbose
 end type CSPOptions
 public :: SP_s_struct_default_options
 public :: SP_d_struct_default_options
 public :: SP_c_struct_default_options
 public :: SP_z_struct_default_options
 public :: SP_s_struct_destroy
 public :: SP_d_struct_destroy
 public :: SP_c_struct_destroy
 public :: SP_z_struct_destroy
 public :: SP_s_struct_rows
 public :: SP_d_struct_rows
 public :: SP_c_struct_rows
 public :: SP_z_struct_rows
 public :: SP_s_struct_cols
 public :: SP_d_struct_cols
 public :: SP_c_struct_cols
 public :: SP_z_struct_cols
 public :: SP_s_struct_memory
 public :: SP_d_struct_memory
 public :: SP_c_struct_memory
 public :: SP_z_struct_memory
 public :: SP_s_struct_nonzeros
 public :: SP_d_struct_nonzeros
 public :: SP_c_struct_nonzeros
 public :: SP_z_struct_nonzeros
 public :: SP_s_struct_rank
 public :: SP_d_struct_rank
 public :: SP_c_struct_rank
 public :: SP_z_struct_rank
 public :: SP_s_struct_from_dense
 public :: SP_d_struct_from_dense
 public :: SP_c_struct_from_dense
 public :: SP_z_struct_from_dense
 public :: SP_s_struct_from_elements
 public :: SP_d_struct_from_elements
 public :: SP_c_struct_from_elements
 public :: SP_z_struct_from_elements
 public :: SP_s_struct_mult
 public :: SP_d_struct_mult
 public :: SP_c_struct_mult
 public :: SP_z_struct_mult
 public :: SP_s_struct_factor
 public :: SP_d_struct_factor
 public :: SP_c_struct_factor
 public :: SP_z_struct_factor
 public :: SP_s_struct_solve
 public :: SP_d_struct_solve
 public :: SP_c_struct_solve
 public :: SP_z_struct_solve
 public :: SP_s_struct_shift
 public :: SP_d_struct_shift
 public :: SP_c_struct_shift
 public :: SP_z_struct_shift

! WRAPPER DECLARATIONS
interface
subroutine SP_s_struct_default_options(opts) &
bind(C, name="SP_s_struct_default_options")
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(CSPOptions) :: opts
end subroutine

subroutine SP_d_struct_default_options(opts) &
bind(C, name="SP_d_struct_default_options")
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(CSPOptions) :: opts
end subroutine

subroutine SP_c_struct_default_options(opts) &
bind(C, name="SP_c_struct_default_options")
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(CSPOptions) :: opts
end subroutine

subroutine SP_z_struct_default_options(opts) &
bind(C, name="SP_z_struct_default_options")
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(CSPOptions) :: opts
end subroutine

subroutine SP_s_struct_destroy(s) &
bind(C, name="SP_s_struct_destroy")
use, intrinsic :: ISO_C_BINDING
type(C_PTR) :: s
end subroutine

subroutine SP_d_struct_destroy(s) &
bind(C, name="SP_d_struct_destroy")
use, intrinsic :: ISO_C_BINDING
type(C_PTR) :: s
end subroutine

subroutine SP_c_struct_destroy(s) &
bind(C, name="SP_c_struct_destroy")
use, intrinsic :: ISO_C_BINDING
type(C_PTR) :: s
end subroutine

subroutine SP_z_struct_destroy(s) &
bind(C, name="SP_z_struct_destroy")
use, intrinsic :: ISO_C_BINDING
type(C_PTR) :: s
end subroutine

function SP_s_struct_rows(s) &
bind(C, name="SP_s_struct_rows") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_d_struct_rows(s) &
bind(C, name="SP_d_struct_rows") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_c_struct_rows(s) &
bind(C, name="SP_c_struct_rows") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_z_struct_rows(s) &
bind(C, name="SP_z_struct_rows") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_s_struct_cols(s) &
bind(C, name="SP_s_struct_cols") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_d_struct_cols(s) &
bind(C, name="SP_d_struct_cols") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_c_struct_cols(s) &
bind(C, name="SP_c_struct_cols") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_z_struct_cols(s) &
bind(C, name="SP_z_struct_cols") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_s_struct_memory(s) &
bind(C, name="SP_s_struct_memory") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_d_struct_memory(s) &
bind(C, name="SP_d_struct_memory") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_c_struct_memory(s) &
bind(C, name="SP_c_struct_memory") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_z_struct_memory(s) &
bind(C, name="SP_z_struct_memory") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_s_struct_nonzeros(s) &
bind(C, name="SP_s_struct_nonzeros") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_d_struct_nonzeros(s) &
bind(C, name="SP_d_struct_nonzeros") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_c_struct_nonzeros(s) &
bind(C, name="SP_c_struct_nonzeros") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_z_struct_nonzeros(s) &
bind(C, name="SP_z_struct_nonzeros") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_LONG_LONG) :: fresult
end function

function SP_s_struct_rank(s) &
bind(C, name="SP_s_struct_rank") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_d_struct_rank(s) &
bind(C, name="SP_d_struct_rank") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_c_struct_rank(s) &
bind(C, name="SP_c_struct_rank") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_z_struct_rank(s) &
bind(C, name="SP_z_struct_rank") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_s_struct_from_dense(s, rows, cols, a, lda, opts) &
bind(C, name="SP_s_struct_from_dense") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
real(C_FLOAT) :: a
integer(C_INT), intent(in), value :: lda
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_d_struct_from_dense(s, rows, cols, a, lda, opts) &
bind(C, name="SP_d_struct_from_dense") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
real(C_DOUBLE) :: a
integer(C_INT), intent(in), value :: lda
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_c_struct_from_dense(s, rows, cols, a, lda, opts) &
bind(C, name="SP_c_struct_from_dense") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_PTR), value :: a
integer(C_INT), intent(in), value :: lda
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_z_struct_from_dense(s, rows, cols, a, lda, opts) &
bind(C, name="SP_z_struct_from_dense") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_PTR), value :: a
integer(C_INT), intent(in), value :: lda
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_s_struct_from_elements(s, rows, cols, arg3, opts) &
bind(C, name="SP_s_struct_from_elements") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_FUNPTR), value :: arg3
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_d_struct_from_elements(s, rows, cols, arg3, opts) &
bind(C, name="SP_d_struct_from_elements") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_FUNPTR), value :: arg3
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_c_struct_from_elements(s, rows, cols, arg3, opts) &
bind(C, name="SP_c_struct_from_elements") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_FUNPTR), value :: arg3
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_z_struct_from_elements(s, rows, cols, arg3, opts) &
bind(C, name="SP_z_struct_from_elements") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
import :: cspoptions
type(C_PTR) :: s
integer(C_INT), intent(in), value :: rows
integer(C_INT), intent(in), value :: cols
type(C_FUNPTR), value :: arg3
type(CSPOptions), intent(in) :: opts
integer(C_INT) :: fresult
end function

function SP_s_struct_mult(s, trans, m, b, ldb, c, ldc) &
bind(C, name="SP_s_struct_mult") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
character(C_CHAR), intent(in), value :: trans
integer(C_INT), intent(in), value :: m
real(C_FLOAT) :: b
integer(C_INT), intent(in), value :: ldb
real(C_FLOAT) :: c
integer(C_INT), intent(in), value :: ldc
integer(C_INT) :: fresult
end function

function SP_d_struct_mult(s, trans, m, b, ldb, c, ldc) &
bind(C, name="SP_d_struct_mult") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
character(C_CHAR), intent(in), value :: trans
integer(C_INT), intent(in), value :: m
real(C_DOUBLE) :: b
integer(C_INT), intent(in), value :: ldb
real(C_DOUBLE) :: c
integer(C_INT), intent(in), value :: ldc
integer(C_INT) :: fresult
end function

function SP_c_struct_mult(s, trans, m, b, ldb, c, ldc) &
bind(C, name="SP_c_struct_mult") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
character(C_CHAR), intent(in), value :: trans
integer(C_INT), intent(in), value :: m
type(C_PTR), value :: b
integer(C_INT), intent(in), value :: ldb
type(C_PTR), value :: c
integer(C_INT), intent(in), value :: ldc
integer(C_INT) :: fresult
end function

function SP_z_struct_mult(s, trans, m, b, ldb, c, ldc) &
bind(C, name="SP_z_struct_mult") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
character(C_CHAR), intent(in), value :: trans
integer(C_INT), intent(in), value :: m
type(C_PTR), value :: b
integer(C_INT), intent(in), value :: ldb
type(C_PTR), value :: c
integer(C_INT), intent(in), value :: ldc
integer(C_INT) :: fresult
end function

function SP_s_struct_factor(s) &
bind(C, name="SP_s_struct_factor") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_d_struct_factor(s) &
bind(C, name="SP_d_struct_factor") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_c_struct_factor(s) &
bind(C, name="SP_c_struct_factor") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_z_struct_factor(s) &
bind(C, name="SP_z_struct_factor") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT) :: fresult
end function

function SP_s_struct_solve(s, nrhs, b, ldb) &
bind(C, name="SP_s_struct_solve") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT), intent(in), value :: nrhs
real(C_FLOAT) :: b
integer(C_INT), intent(in), value :: ldb
integer(C_INT) :: fresult
end function

function SP_d_struct_solve(s, nrhs, b, ldb) &
bind(C, name="SP_d_struct_solve") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT), intent(in), value :: nrhs
real(C_DOUBLE) :: b
integer(C_INT), intent(in), value :: ldb
integer(C_INT) :: fresult
end function

function SP_c_struct_solve(s, nrhs, b, ldb) &
bind(C, name="SP_c_struct_solve") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT), intent(in), value :: nrhs
type(C_PTR), value :: b
integer(C_INT), intent(in), value :: ldb
integer(C_INT) :: fresult
end function

function SP_z_struct_solve(s, nrhs, b, ldb) &
bind(C, name="SP_z_struct_solve") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
integer(C_INT), intent(in), value :: nrhs
type(C_PTR), value :: b
integer(C_INT), intent(in), value :: ldb
integer(C_INT) :: fresult
end function

function SP_s_struct_shift(s, s1) &
bind(C, name="SP_s_struct_shift") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
real(C_FLOAT), intent(in), value :: s1
integer(C_INT) :: fresult
end function

function SP_d_struct_shift(s, s1) &
bind(C, name="SP_d_struct_shift") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
real(C_DOUBLE), intent(in), value :: s1
integer(C_INT) :: fresult
end function

function SP_c_struct_shift(s, s1) &
bind(C, name="SP_c_struct_shift") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
complex(C_FLOAT_COMPLEX), intent(in), value :: s1
integer(C_INT) :: fresult
end function

function SP_z_struct_shift(s, s1) &
bind(C, name="SP_z_struct_shift") &
result(fresult)
use, intrinsic :: ISO_C_BINDING
type(C_PTR), intent(in), value :: s
complex(C_DOUBLE_COMPLEX), intent(in), value :: s1
integer(C_INT) :: fresult
end function

end interface


end module
